#!/usr/bin/env python

from mod_python import apache
import time
import string
import sys

from mpl_web import *
import ssx

client_side_xslt = True

mpl = apache.import_module("mplcore", path=[mpl_root], autoreload = 1, log = 1)

def user_agent(req):
	req.add_common_vars()
	if req.subprocess_env.has_key("HTTP_USER_AGENT"):
		return req.subprocess_env["HTTP_USER_AGENT"]
	return "unknown"

def is_ie(browser):
	if browser.find("MSIE") > 0:
		return True
	if browser.find("Gecko") > 0:
		return False
	if browser.find("Konqueror") > 0:
		return False
	if browser.find("Windows") > 0:
		return True
	return False

def handle_module(req, xml, module):
	sub = apache.import_module(module, path=[document_root], autoreload = 1, log = 1)
	return sub.handler(req,xml, mpl.conf)

def handler_public(req):
	modules = ["index", "vendor", "search", "request"]
	return handler_int(req, "style/mpl.xslt", modules)

def handler_op(req):
	modules = ["op/index", "op/vendor", "op/search", "op/vendor-edit", "op/good-edit"]
	return handler_int(req, "style/mpl-op.xslt", modules)

handler = handler_public

def handler_int(req, stylesheet, modules): 
	output = "xslt"
	if req.args:
		import cgi
		args = cgi.parse_qs(req.args, keep_blank_values = True, strict_parsing = True)
		if args.has_key("output"):
			output = args["output"][0]
	if output != "xml": 
		output = "xslt"

	xml = ssx.SSXML() 
	xml.data("<?xml-stylesheet type='text/xsl' href='%s'?>\n" % stylesheet)
	xml.push("ssx:doc", """
		xmlns='http://www.w3.org/1999/xhtml'
		xmlns:ssx='%s'
		xmlns:mpl='%s'""" % (ssx.xmlns, mpl.xmlns))
	xml.data("<ssx:css href='style/mpl.css'/>\n")

	timer = time.time()

	module = req.filename
	if module[0:len(document_root)] == document_root:
		module = module[len(document_root):]
		if len(module) > 3 and module[len(module)-3:] == ".py":
			module = module[0:len(module)-3]

	#counter = 0
	try :
		xml.push("ssx:body")
		xml.data("<mpl:header/>\n")
		xml.data("<mpl:menu/>")
		if modules.count(module) == 0:
			xml.data("<ssx:error>Unknown module: %s </ssx:error>\n" % module);
			module = "index"
		handle_module(req, xml, module)
		#counter = add_counter(module)
		xml.pop("ssx:body")
	except RuntimeError, e:
		xml.pop("ssx:body")
		xml.data("<ssx:error>"+ e.__str__() +"</ssx:error>\n");
	except ssx.SSXRedirect, e:
		req.err_headers_out.add('Location', e.url)
		req.status = apache.HTTP_MOVED_TEMPORARILY
		return apache.OK
	"""
	except:
		xml.pop("ssx:body")
		xml.data("<ssx:error>Internal error</ssx:error>\n");
		"""

	xml.push("ssx:meta")
	xml.data("<ssx:line>"+time.ctime()+"</ssx:line>\n");
	xml.data("<ssx:timer type='web'>%.3f</ssx:timer>" % (timer - req.request_time))
	xml.data("<ssx:timer type='query'>%.3f</ssx:timer>" % (time.time() - timer))
	if output != "xml":
		xml.data("<ssx:timer type='xslt'><xslt-timing/></ssx:timer>")
		sep = "?"
		if req.unparsed_uri.find('?') > 0:
			sep = '&amp;'
		import cgi
		xml.data("<ssx:line><a href='%s%soutput=xml'>xml</a></ssx:line>\n" % (mpl.api.xmlq(req.unparsed_uri), sep))
	#xml.data("<ssx:line>counter: %d</ssx:line>\n" % counter)
	#xml.data("<ssx:line>agent: %s</ssx:line>\n" % user_agent(req))
	xml.pop()
	timer = time.time()
	if output == "xml":
		req.content_type="text/xml; charset=UTF-8";
		req.write(xml.text());
		return apache.OK
	
	msie = is_ie(user_agent(req))
		
	xslt = ssx.SSXSLT(document_root + "/" + stylesheet)
	tmp = xslt.xslt(xml.text())

	if msie:
		req.content_type="text/html; charset=UTF-8";
		ind = tmp.find("<html")
		tmp = tmp[ind:]
		tmp = tmp.replace('xmlns="http://www.w3.org/1999/xhtml"', "")
	else:
		req.content_type="application/xhtml+xml; charset=UTF-8";
	tmp = string.replace(tmp, "<xslt-timing/>", "%.3f" % (time.time() - timer))


	#req.write(string.replace(tmp, 'xmlns:fss="http://asp.mexmat.net/xmlns/fss"', ""))
	req.write(tmp)
	return apache.OK 
